module Simbiotes
  class CreateModelGenerator < Rails::Generators::Base
    source_root File.expand_path('../templates', __FILE__)
    argument :parent, :type => :string
    argument :name, :type => :string
    argument :portal, :type => :string, :required => false
  
    def copy_model_file
      if portal == "true"
        @c = Simbiotes.get_attributes(parent, name)
      end
      @targets = Simbiotes::Portal.parse_all_interfaces
      template "simbiotes_module.rb.erb", "app/models/#{module_file_name}.rb"
      unless File.exist?("app/models/#{module_file_name}/#{module_file_name}.rb")
        template "create_module_model_table.rb.erb", "db/migrate/#{date_string}_create_#{plural_name}.rb"
      end
      template "simbiotes_module_model.rb.erb", "app/models/#{module_file_name}/#{module_file_name}.rb"
      template "simbiotes_model.rb.erb", "app/models/#{module_file_name}/#{file_name}.rb"
      unless Simbiotes.configuration.local_logging == false
        if portal == "true"
          @c[:attributes].each do |k,v|
            @k = k
            @v = v
            template "simbiotes_logs_model.rb.erb", "app/models/#{module_file_name}/#{file_name}_#{@k.underscore.downcase.gsub(" ","_")}_log.rb"
          end
        else
          @k = name
          template "simbiotes_logs_model.rb.erb", "app/models/#{module_file_name}/#{file_name}_#{@k.underscore.downcase.gsub(" ","_")}_log.rb"
        end
      end
    end
    
    private
    
    def file_name
      name.underscore
    end
    
    def module_file_name
      parent.underscore
    end
    
    def class_name
      name.classify
    end
    
    def module_name
      parent.classify
    end
    
    def table_prefix
      parent.underscore + "_"
    end
    
    def plural_name
      parent.underscore.pluralize
    end
    
    def plural_table_name
      parent.underscore + "_" + parent.underscore.pluralize
    end
    
    def plural_class_name
      parent.classify + name.classify.pluralize
    end
    
    def plural_module_name
      parent.classify.pluralize
    end
    
    def date_string
      date_string = DateTime.now.strftime("%Y%m%d%H%M%S")
    end
    
  end
end
