module Simbiotes
  class ModelGenerator < Rails::Generators::Base
    source_root File.expand_path('../templates', __FILE__)
    argument :parent, :type => :string
    argument :name, :type => :string
    argument :attributes, :type => :hash, :required => false
    
    def run_generators
      generate "simbiotes:create_table", arguments
      if @c == nil
        generate "simbiotes:create_model", "#{parent} #{name}"
      else
        generate "simbiotes:create_model", thorify
        generate "simbiotes:initializer", "true"
      end
    end
    
    private
    
    def arguments
      if attributes == nil
        return get_attributes
      else
        return parent.to_s + " " + name.to_s + " " + stringify
      end
    end
    
    def stringify
      string = String.new
      attributes.each do |k,v|
        string = string + k + ":" + v + " "
      end
      string
    end
    
    def get_attributes
      @c = Simbiotes.get_attributes(parent, name)
      if @c[:kind] == "script"
        generate "simbiotes:script", "#{parent} #{name}"
      end
      string = String.new
      @c[:attributes].each do |k,v|
        if v[:type] == "enum"
          string = string + k.gsub(" ", "_").downcase + ":" + "integer" + " "
        else
          string = string + k.gsub(" ", "_").downcase + ":" + v[:type] + " "
        end
      end
      return parent.to_s + " " + name.to_s + " " + string
    end
    
    def thorify
      string = String.new
      string = parent.to_s + " " + name.to_s + " " + "true"
    end
    
  end
end
