require 'simbiotes/configuration'
require "simbiotes/version"
require 'simbiotes/server'
require 'simbiotes/client'
require 'simbiotes/parse'
require 'simbiotes/insert'
require 'simbiotes/extract'
require 'simbiotes/portal'
require 'daemons'

module Simbiotes
  
  class << self
    attr_accessor :configuration
  end
  
  def self.configuration
    @configuration ||= Configuration.new
  end
  
  def self.reset
    @configuration = Configuration.new
  end
  
  def self.configure
    yield(configuration)
  end
  
  def self.get(object, time0= nil, time1= nil)
    Simbiotes::Extract.get(object, time0, time1)
  end
  
  def self.get_attributes(parent_name, model_name)
    configuration = Simbiotes::Portal.retrieve_configuration
    attributes = Simbiotes::Portal.parse_drivers_and_scripts(configuration, parent_name, model_name)
  end
  
  def self.sync_device_instances(worker_name)
    Simbiotes::Portal.sync_device_instances(worker_name)
  end
  
  def self.sync(object)
    parent = object.class.parent.name
    child = object.class.name.demodulize
    attributes = Simbiotes.configuration.targets[parent][child]
    interfaces = Hash.new
    attributes.each do |attribute|
      interfaces[attribute.underscore.downcase.gsub(" ", "_")] = object.send(attribute.underscore.downcase.gsub(" ", "_")).to_s
    end
    Simbiotes::Extract.fire(object, interfaces, "get")
  end
  
  def self.clear_settings
    SimbiotesSetting.destroy_all
  end
    
end
